#include "main.h"
#include "Box2D.h"
// #include <vector>
//using namespace std;

// a sample exported function
//void DLL_EXPORT SomeFunction(const LPCSTR sometext)
//{
//    MessageBoxA(0, sometext, "DLL Message", MB_OK | MB_ICONINFORMATION);
//}
//int  DLL_EXPORT HelloBox2D()
//{
//    return 1234;
//}

b2World * pWorld; // this is our world. it is global. it needs to be preserved.

// initialize pWorld
// according to parameters
// extern "C" void DLL_EXPORT STDCALL b2dll_initWorld( float aabbxl, float aabbxh, float aabbyl, float aabbyh, float gx, float gy, bool doSleep ){
//void DLL_EXPORT STDCALL zgeMakeWorld()
//{
//    // create world
//	b2AABB worldAABB;
//	worldAABB.lowerBound.Set(-100.0f, -100.0f);
//	worldAABB.upperBound.Set(100.0f, 100.0f);
//	b2Vec2 gravity(0.0f, -10.0f);
//	bool doSleep = true;
//	// b2World foo(worldAABB, gravity, doSleep);
//	// world = foo;
//	pWorld = new b2World( worldAABB, gravity, doSleep );
//	// create ground body
//	b2BodyDef groundBodyDef;
//	groundBodyDef.position.Set(0.0f, -10.0f);
//	b2Body* groundBody = pWorld->CreateBody(&groundBodyDef);
//	b2PolygonDef groundShapeDef;
//	groundShapeDef.SetAsBox(50.0f, 10.0f);
//	groundBody->CreateShape(&groundShapeDef);
//}

extern "C" void DLL_EXPORT STDCALL b2dll_InitWorld( float aabbxl, float aabbxh, // bounding box x limits
                                         float aabbyl, float aabbyh, // bounding box y limits
                                         float gx, float gy, // gravity
                                         int doSleep ){ // turn simulation off on resting bodies
    // bounding box
	b2AABB worldAABB;
	worldAABB.lowerBound.Set( aabbxl, aabbyl );
	worldAABB.upperBound.Set( aabbxh, aabbyh );
	// gravity
	b2Vec2 gravity( gx, gy );
	// initialisation
	pWorld = new b2World( worldAABB, gravity, ( doSleep >0 ) );
}
int DLL_EXPORT STDCALL b2dll_GetBodyCount( ){
    return pWorld->GetBodyCount();
}
void DLL_EXPORT STDCALL b2dll_Step( float timestep, int iterations ){
    pWorld->Step( timestep, iterations );
}
b2Body* DLL_EXPORT STDCALL b2dll_CreateStaticBox( float x, float y, // position
                                                  float width, float height ){ // dimension
    b2BodyDef bodyDef;
	bodyDef.position.Set( x, y );
	b2Body* body = pWorld->CreateBody(&bodyDef);
	b2PolygonDef shapeDef;
	shapeDef.SetAsBox( width, height );
	body->CreateShape( &shapeDef );
	return body;
}
b2Body* DLL_EXPORT STDCALL b2dll_CreateDynamicBox( float x, float y, // position
                                                   float width, float height ){ // dimension
    // define dynamic body
    b2BodyDef bodyDef;
	bodyDef.position.Set( x, y );
	b2Body* body = pWorld->CreateBody(&bodyDef);
	// Define box shape for our dynamic body.
	b2PolygonDef shapeDef;
	shapeDef.SetAsBox( width, height );
	// Set the box density to be non-zero, so it will be dynamic.
	shapeDef.density = 1.0f;
	// Override the default friction.
	shapeDef.friction = 0.3f;
	// Add the shape to the body.
	body->CreateShape( &shapeDef );
	// Now tell the dynamic body to compute it's mass properties base
	// on its shape.
	body->SetMassFromShapes();
    return body;
}
float DLL_EXPORT STDCALL b2dll_GetPositionX( b2Body* body ){
    b2Vec2 position = body->GetPosition();
    return position.x;
}
float DLL_EXPORT STDCALL b2dll_GetPositionY( b2Body* body ){
    b2Vec2 position = body->GetPosition();
    return position.y;
}
float DLL_EXPORT STDCALL b2dll_GetAngle( b2Body* body ){
    float32 angle = body->GetAngle();
    return angle;
}

// ================================

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // attach to process
            // return FALSE to fail DLL load
            break;

        case DLL_PROCESS_DETACH:
            // detach from process
            break;

        case DLL_THREAD_ATTACH:
            // attach to thread
            break;

        case DLL_THREAD_DETACH:
            // detach from thread
            break;
    }
    return TRUE; // succesful
}
