#ifndef __MAIN_H__
#define __MAIN_H__

#include <windows.h>

#include "Box2D.h"

/*  To use this exported function of dll, include this header
 *  in your project.
 */

#ifdef BUILD_DLL
    #define DLL_EXPORT __declspec(dllexport)
#else
    #define DLL_EXPORT __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C"
{
#endif

// the following are for real now

// ================== WORLD
// init the world
void DLL_EXPORT STDCALL b2dll_InitWorld( float aabbxl, float aabbxh, // bounding box lower limits
                                         float aabbyl, float aabbyh, // bounding box upper limits
                                         float gx, float gy, // gravity
                                         int doSleep ); // turn simulation off on resting bodies
// advance the simulation
void DLL_EXPORT STDCALL b2dll_Step( float timestep, int iterations );
// count bodies
int DLL_EXPORT STDCALL b2dll_GetBodyCount( );

// ================== BODIES
// create a static box (e.g. ground)
b2Body* DLL_EXPORT STDCALL b2dll_CreateStaticBox( float x, float y,
                                                  float width, float height );
// create a dynamic box
b2Body* DLL_EXPORT STDCALL b2dll_CreateDynamicBox( float x, float y, // position
                                                   float width, float height ); // dimension
// getters
float DLL_EXPORT STDCALL b2dll_GetPositionX( b2Body* body );
float DLL_EXPORT STDCALL b2dll_GetPositionY( b2Body* body );
float DLL_EXPORT STDCALL b2dll_GetAngle( b2Body* body );
#ifdef __cplusplus
}
#endif

#endif // __MAIN_H__
